// auto generated by go tool dist

// On Linux systems, what we call 0(GS) and 4(GS) for g and m
// turn into %gs:-8 and %gs:-4 (using gcc syntax to denote
// what the machine sees as opposed to 8l input).
// 8l rewrites 0(GS) and 4(GS) into these.
//
// On Linux Xen, it is not allowed to use %gs:-8 and %gs:-4
// directly.  Instead, we have to store %gs:0 into a temporary
// register and then use -8(%reg) and -4(%reg).  This kind
// of addressing is correct even when not running Xen.
//
// 8l can rewrite MOVL 0(GS), CX into the appropriate pair
// of mov instructions, using CX as the intermediate register
// (safe because CX is about to be written to anyway).
// But 8l cannot handle other instructions, like storing into 0(GS),
// which is where these macros come into play.
// get_tls sets up the temporary and then g and r use it.
//
// Another wrinkle is that get_tls needs to read from %gs:0,
// but in 8l input it's called 8(GS), because 8l is going to
// subtract 8 from all the offsets, as described above.
//
// The final wrinkle is that when generating an ELF .o file for
// external linking mode, we need to be able to relocate the
// -8(r) and -4(r) instructions. Tag them with an extra (GS*1)
// that is ignored by the linker except for that identification.
#define	get_tls(r)	MOVL 8(GS), r
#define	g(r)	-8(r)(GS*1)
#define	m(r)	-4(r)(GS*1)
#define gobuf_sp 0
#define gobuf_pc 4
#define gobuf_g 8
#define g_stackguard 0
#define g_stackbase 4
#define g_defer 8
#define g_panic 12
#define g_sched 16
#define g_gcstack 28
#define g_gcsp 32
#define g_gcpc 36
#define g_gcguard 40
#define g_stack0 44
#define g_fnstart 48
#define g_alllink 52
#define g_param 56
#define g_status 60
#define g_goid 64
#define g_selgen 72
#define g_waitreason 76
#define g_schedlink 80
#define g_ispanic 84
#define g_issystem 85
#define g_isbackground 86
#define g_blockingsyscall 87
#define g_raceignore 88
#define g_m 92
#define g_lockedm 96
#define g_sig 100
#define g_writenbuf 104
#define g_writebuf 108
#define g_dchunk 112
#define g_dchunknext 116
#define g_sigcode0 120
#define g_sigcode1 124
#define g_sigpc 128
#define g_gopc 132
#define g_racectx 136
#define g_end 140
#define m_g0 0
#define m_morepc 4
#define m_moreargp 8
#define m_morebuf 12
#define m_moreframesize 24
#define m_moreargsize 28
#define m_cret 32
#define m_procid 36
#define m_gsignal 44
#define m_tls 48
#define m_mstartfn 64
#define m_curg 68
#define m_p 72
#define m_nextp 76
#define m_id 80
#define m_mallocing 84
#define m_throwing 88
#define m_gcing 92
#define m_locks 96
#define m_nomemprof 100
#define m_dying 104
#define m_profilehz 108
#define m_helpgc 112
#define m_blockingsyscall 116
#define m_spinning 117
#define m_fastrand 120
#define m_ncgocall 124
#define m_ncgo 132
#define m_cgomal 136
#define m_park 140
#define m_alllink 144
#define m_schedlink 148
#define m_machport 152
#define m_mcache 156
#define m_stackinuse 160
#define m_stackcachepos 164
#define m_stackcachecnt 168
#define m_stackcache 172
#define m_lockedg 300
#define m_createstack 304
#define m_freglo 432
#define m_freghi 496
#define m_fflag 560
#define m_locked 564
#define m_nextwaitm 568
#define m_waitsema 572
#define m_waitsemacount 576
#define m_waitsemalock 580
#define m_gcstats 584
#define m_racecall 624
#define m_needextram 625
#define m_racepc 628
#define m_waitunlockf 632
#define m_waitlock 636
#define m_moreframesize_minalloc 640
#define m_settype_buf 644
#define m_settype_bufsize 4740
#define m_seh 4744
#define m_end 4748
#define wincall_fn 0
#define wincall_n 4
#define wincall_args 8
#define wincall_r1 12
#define wincall_r2 16
#define wincall_err 20
#define seh_prev 0
#define seh_handler 4
